<?php
class User extends YuniccDatabaseRecordClass
{
	public $fill_query = "SELECT * FROM users WHERE `Id` = '%d'";
	public $verify_query = "SELECT * FROM users WHERE `Id` = '%d'";
	public $render_template = "";
	
	public $sMemberships = array();
	public $sCurrentCommunityId = 0;
	
	public $prototype = array(
		'string' => array(
			'DisplayName'		=> "DisplayName",
			'Email'				=> "Username",
			'PasswordHash'		=> "Password",
			'Salt'				=> "Salt",
			'ActivationCode'	=> "ActivationCode",
			'RecoveryCode'		=> "RecoveryCode",
			'Signature'			=> "Signature"
		),
		'numeric' => array(
			'AccountStatus'		=> "AccountStatus",
			'RecoveryStatus'	=> "RecoverStatus"
		),
		'timestamp' => array(
			'RegistrationDate'	=> "RegisterDate"
		)
	);
	
	public $prototype_render = array(
		'id'			=> "Id",
		'name'			=> "DisplayName",
		'rank'			=> "RankName",
		'rank-class'	=> "RankClassName"
	);
	
	public function AddMembership($sCommunityId, $sUsergroupId = 0)
	{
		if(empty($sUsergroupId))
		{
			$sMembership = new Membership($this->sId, $sCommunityId);
		}
		else
		{
			$sMembership = new Membership(0);
			$sMembership->sUserId = $this->sId;
			$sMembership->sCommunityId = $sCommunityId;
			$sMembership->sUsergroupId = $sUsergroupId;
			$sMembership->sUsergroup = new Usergroup($sUsergroupId);
		}
		
		$this->sMemberships[$sCommunityId] = $sMembership;
		$this->sCurrentCommunityId = $sCommunityId;
	}
	
	public function RenderTemplate($template, $sCommunityId = 0)
	{
		if($template == YUNICC_TEMPLATE_STAFF_OVERVIEW)
		{
			$this->render_template = "element.community.overview.staffmember";
		}
		else
		{
			throw new Exception("Template {$template} is not associated with this object.");
		}
		
		$sCurrentMembership = $this->sMemberships[$this->sCurrentCommunityId];
		$this->sRankName = $sCurrentMembership->sUsergroup->sName;
		$this->sRankClassName = $sCurrentMembership->sUsergroup->sClass;
		return $this->DoRenderInternalTemplate();
	}
}
?>
